import type { App } from '@opentinyvue/vue-common';
import type { ILoadingState } from '@opentinyvue/vue-renderless/types/loading.type';
interface LoadingConfig {
    text?: string | null;
    body?: boolean;
    lock?: boolean;
    customClass?: string;
    fullscreen?: boolean;
    iconSize?: string;
    target?: HTMLElement | string;
    size?: string;
    loadingImg?: string;
    tiny_mode?: string;
}
interface LoadingInstance {
    state: ILoadingState;
    $el: HTMLElement;
    originalPosition?: string;
    originalOverflow?: string;
}
type LoadingService = (config?: LoadingConfig) => LoadingInstance;
interface LoadingPlugin {
    install: (app: App) => void;
    service: LoadingService;
    directive: any;
    version: string;
}
declare const Loadings: LoadingPlugin;
export default Loadings;
