/**
 * Copyright (c) 2022 - present TinyVue Authors.
 * Copyright (c) 2022 - present Huawei Cloud Computing Technologies Co., Ltd.
 *
 * Use of this source code is governed by an MIT-style license.
 *
 * THE OPEN SOURCE SOFTWARE IN THIS PRODUCT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,
 * BUT WITHOUT ANY WARRANTY, WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR
 * A PARTICULAR PURPOSE. SEE THE APPLICABLE LICENSES FOR MORE DETAILS.
 *
 */
import type { ILoadingState } from '@opentinyvue/vue-renderless/types/loading.type';
interface LoadingConfig {
    text?: string | null;
    body?: boolean;
    lock?: boolean;
    customClass?: string;
    fullscreen?: boolean;
    iconSize?: string;
    target?: HTMLElement | string;
    size?: string;
    loadingImg?: string;
    tiny_mode?: string;
}
interface LoadingInstance {
    state: ILoadingState;
    $el: HTMLElement;
    originalPosition?: string;
    originalOverflow?: string;
}
export declare const defaults: LoadingConfig;
export declare const constants: {
    TEXT_ATTR: string;
    IS_FULLSCREEN_CLS: string;
    TEXT_SPINNER: string;
    TEXT_BACKGROUND: string;
    TEXT_CUSTOM_CLS: string;
    PARENT_HIDDEN_CLS: string;
    PARENT_RELATIVE_CLS: string;
    LOAD_ICON_TEXT: string;
};
declare const _default: (configs?: LoadingConfig) => LoadingInstance;
export default _default;
